﻿Public Class Form1
    Public ByteCnt As Integer                                     '' Счетчик количества загуженых байт
    Public FileBuff(1024) As Byte                               '' Буфер для загружаемого файла
    Private Sub TrackBar1_ValueChanged(sender As Object, e As EventArgs) Handles TrackBar1.ValueChanged
        Label5.Text = TrackBar1.Value
    End Sub

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        ComboBox1.SelectedIndex = 13
        '' Определяем порты в системе и выводм их
        For Each sp As String In My.Computer.Ports.SerialPortNames
            ComboBox2.Items.Add(sp)
            ComboBox2.SelectedIndex = 0
        Next
        ToolTip1.SetToolTip(TextBox1, "Только английские заглавные буквы, цифры, символы 'дробь' и 'вопрос', символ 'минус' дает тон 5 секунд, символ 'равно' тон 10 секунд!")
    End Sub

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click
        Dim i As Integer
        Dim s As String
        Dim ch As Byte
        Dim FullTime As Integer
        FileBuff(0) = ComboBox1.SelectedIndex
        FullTime = CUInt(TrackBar1.Value)
        Dim ByteArray As Byte() = BitConverter.GetBytes(FullTime)
        FileBuff(1) = ByteArray(1)
        FileBuff(2) = ByteArray(0)
        s = TextBox1.Text
        FileBuff(3) = s.Length
        s = s.PadRight(240, " ")
        For i = 0 To 239
            ch = Asc(s.Chars(i))
            If (ch >= 48 And ch <= 57) Or (ch >= 65 And ch <= 90) Or (ch = 63) Or (ch = 47) Or (ch = 32) Or (ch = 45) Or (ch = 61) Or (ch = 42) Then
                FileBuff(i + 4) = Asc(s.Chars(i))
            Else
                FileBuff(i + 4) = 32
                Dim result = MessageBox.Show("Неизветсные символы", "Ошибка", MessageBoxButtons.OK, MessageBoxIcon.Error)
                Return
            End If
        Next
        SerialPort1.Close()
        SerialPort1.PortName = ComboBox2.Text
        SerialPort1.Open()
        SerialPort1.DiscardInBuffer()
        SerialPort1.Write("R")
        ByteCnt = 0
        ProgressBar1.Value = ByteCnt
        Timer1.Enabled = True
        Panel1.Enabled = False
    End Sub

    Private Sub Timer1_Tick(sender As Object, e As EventArgs) Handles Timer1.Tick
        Dim a As Byte
        Try
            a = SerialPort1.ReadByte()
            If a = 82 Then
                SerialPort1.DiscardOutBuffer()
                Timer1.Enabled = False
                Timer2.Enabled = True
            End If
        Catch ex As TimeoutException
            Timer1.Enabled = False
            Panel1.Enabled = True
            Dim result = MessageBox.Show("Контроллер маяка не отвечает", "Ошибка", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    Private Sub Timer2_Tick(sender As Object, e As EventArgs) Handles Timer2.Tick
        SerialPort1.Write(FileBuff, ByteCnt, 1)
        ProgressBar1.Value = ByteCnt + 1
        ByteCnt = ByteCnt + 1
        If ByteCnt >= 252 Then
            Timer2.Enabled = False
            Panel1.Enabled = True
            SerialPort1.Close()
            Dim result = MessageBox.Show("Загрузка завершена", "Информация", MessageBoxButtons.OK, MessageBoxIcon.Information)
            ProgressBar1.Value = 0
        End If
    End Sub

    Private Sub TextBox1_TextChanged(sender As Object, e As EventArgs) Handles TextBox1.TextChanged

    End Sub

    Private Sub TextBox1_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TextBox1.KeyPress
        Dim Nu As String = e.KeyChar
        Dim num As Byte
        num = Asc(Nu.Chars(0))
        If (num < 48 Or num > 57) And (num < 65 Or num > 90) And (num <> 63) And (num <> 47) And (num <> 32) And (num <> 8) And (num <> 45) And (num <> 61) And (num <> 42) Then
            e.Handled = True
        End If
    End Sub
    Private Sub Button15_Click(sender As Object, e As EventArgs) Handles Button15.Click
        TrackBar1.Value = 5
    End Sub
    Private Sub Button14_Click(sender As Object, e As EventArgs) Handles Button14.Click
        TrackBar1.Value = 10
    End Sub
    Private Sub Button2_Click(sender As Object, e As EventArgs) Handles Button2.Click
        TrackBar1.Value = 15
    End Sub
    Private Sub Button3_Click(sender As Object, e As EventArgs) Handles Button3.Click
        TrackBar1.Value = 30
    End Sub
    Private Sub Button5_Click(sender As Object, e As EventArgs) Handles Button5.Click
        TrackBar1.Value = 60
    End Sub
    Private Sub Button4_Click(sender As Object, e As EventArgs) Handles Button4.Click
        TrackBar1.Value = 120
    End Sub
    Private Sub Button9_Click(sender As Object, e As EventArgs) Handles Button9.Click
        TrackBar1.Value = 180
    End Sub
    Private Sub Button8_Click(sender As Object, e As EventArgs) Handles Button8.Click
        TrackBar1.Value = 240
    End Sub
    Private Sub Button7_Click(sender As Object, e As EventArgs) Handles Button7.Click
        TrackBar1.Value = 300
    End Sub
    Private Sub Button6_Click(sender As Object, e As EventArgs) Handles Button6.Click
        TrackBar1.Value = 600
    End Sub
    Private Sub Button13_Click(sender As Object, e As EventArgs) Handles Button13.Click
        TrackBar1.Value = 900
    End Sub
    Private Sub Button12_Click(sender As Object, e As EventArgs) Handles Button12.Click
        TrackBar1.Value = 1200
    End Sub
    Private Sub Button11_Click(sender As Object, e As EventArgs) Handles Button11.Click
        TrackBar1.Value = 2400
    End Sub
    Private Sub Button10_Click(sender As Object, e As EventArgs) Handles Button10.Click
        TrackBar1.Value = 3600
    End Sub

    Private Sub Label3_Click(sender As Object, e As EventArgs) Handles Label3.Click

    End Sub

    Private Sub Label9_Click(sender As Object, e As EventArgs) Handles Label9.Click

    End Sub
End Class
